import Circle from "class/Circle";

export default class extends Circle{

  constructor(x, y , r, velocityX, velocityY, maxX, maxY, color = null, borderColor = null) {
    super(x, y , r, 0, color, borderColor);
    this.maxX = maxX;
    this.maxY = maxY;
    this.vX = velocityX;
    this.vY = velocityY;
    this.gravity = 10;
  }

  applyFriction(deltaT, friction = 0.0001) {
    // Ne respecte pas la physique mais donne une bonne illusion
    if (this.vX > 0) {
      this.vX -=  friction * deltaT;
      this.vX = Math.max(0, this.vX);
    } else {
      this.vX +=  friction * deltaT;
      this.vX = Math.min(0, this.vX);
    }
    if (this.vY > 0) {
      this.vY -=  friction * deltaT;
      this.vY = Math.max(0, this.vY);
    } else {
      this.vY +=  friction * deltaT;
      this.vY = Math.min(0, this.vY);
    }
  }

  applyFloorFriction(deltaT, friction = 0.001) {
    if (this.y + this.r >= this.maxY) {
      this.applyFriction(deltaT, friction);
    }
  }

  applyGravity(deltaT, gravity = null) {
    if (gravity !== null) {
      this.gravity = gravity;
    }
    this.vY += this.gravity/1000 * deltaT;
  }

  bounceOffTheWalls(withGravity = false) {
    if (this.x + this.r >= this.maxX) {
      this.vX = - Math.abs(this.vX);
      this.x = this.maxX - this.r;
    } else if (this.x - this.r <= 0) {
      this.vX = + Math.abs(this.vX);
      this.x = 0 + this.r;
    }
    if (this.y + this.r >= this.maxY) {
      // Gestion de "l'élascticité"
      // (ne respecte pas la physique mais fournit une bonne illusion)
      if (withGravity) {
        this.vY -= this.gravity / 10; // perte d'énérgie au rebond
        this.vY = Math.max(0, this.vY);
      }
      this.vY = - Math.abs(this.vY);
      this.y = this.maxY - this.r;
    } else if (this.y - this.r <= 0) {
      this.vY = + Math.abs(this.vY);
      this.y = 0 + this.r;
    }
  }

  move(deltaT) {
    this.x += this.vX * deltaT;
    this.y += this.vY * deltaT;
  }

}