import Circle from "class/Circle";

export default class extends Circle{

  constructor(x, y , r, speed, color = null, borderColor = null, eyesAngle = 0) {
    super(x, y , r, speed, color, borderColor);
    this.eyeDist = this.r / 4;
    this.pupillaryDist =  this.r / 2.5;
    this.eyesAngle = eyesAngle;
  }

  draw(ctx) {
    super.draw(ctx);
    var eyeDistX = this.eyeDist * Math.cos(this.eyesAngle);
    var eyeDistY = this.eyeDist * Math.sin(this.eyesAngle);
    var pupillaryDistX = this.pupillaryDist * Math.cos(this.eyesAngle);
    var pupillaryDistY = this.pupillaryDist * Math.sin(this.eyesAngle);
    ctx.fillStyle = "white";
    ctx.strokeStyle = this.borderColor;
    // right eye
    ctx.beginPath();
    ctx.arc(this.x + eyeDistX - pupillaryDistX, this.y + eyeDistY - pupillaryDistY, this.eyeDist, 0, 2 * Math.PI);
    ctx.closePath();
    ctx.fill();
    // left eye
    ctx.beginPath();
    ctx.arc(this.x + eyeDistX + pupillaryDistX, this.y + eyeDistY + pupillaryDistY, this.eyeDist, 0, 2 * Math.PI);
    ctx.closePath();
    ctx.fill();
    // pupils
    ctx.fillStyle = "black";
    ctx.fillRect(this.x + eyeDistX + pupillaryDistX, this.y + eyeDistY + pupillaryDistY, 1, 1);
    ctx.fillRect(this.x + eyeDistX - pupillaryDistX, this.y + eyeDistY - pupillaryDistY, 1, 1);
  }

}