import {moduloEuclidian} from 'lib/Math';
import LikeLifeAutomaton from "class/LifeLikeAutomaton";

export default class extends LikeLifeAutomaton {

  countAliveMooreNeighborhood(posX, posY, chebyshevDistance = 1) {
    let startX = posX - chebyshevDistance;
    let endX = posX + chebyshevDistance;
    let startY = posY - chebyshevDistance;
    let endY = posY + chebyshevDistance;
    let nbAliveNeighbors = 0;
    for (let x = startX; x <= endX; x++) {
      for (let y = startY; y <= endY; y++) {
        if (this.map[moduloEuclidian(x, this.width)][moduloEuclidian(y, this.height)]) {
          nbAliveNeighbors++;
        }
      }
    }
    return nbAliveNeighbors;
  }

}


